//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com]

package master;

import javax.swing.JOptionPane;

public class Monitor {

	private boolean stringEncontrada = false;
	private int nCaracteres = 1;
	private int nSlave = 0;
	private String stringLetras = "abcdefghijklmnopqrstuvwyxzABCDEFGHIJKLMNOPQRSTUVWYXZ";
	public int nTotalSlaves;
	private int ultimaPosicaoFinal;
	
	public Monitor(int nslaves) { 
		this.nTotalSlaves = nslaves;
	}
	public synchronized void setTotalSlaves(int i) { 
		nTotalSlaves = i;
	}
	
	public synchronized int getTotalSlaves() {
		return nTotalSlaves;
	}
	
	public synchronized String[] getStrings() {
		return gerarString();
	}
	
	private  synchronized String[] gerarString() {
		
		char[] c = new char[nCaracteres];
		int posicaoInicial = nSlave * (stringLetras.length() / nTotalSlaves);
		char charInicial = stringLetras.charAt(posicaoInicial);
		if (posicaoInicial < ultimaPosicaoFinal) { 
			posicaoInicial = ultimaPosicaoFinal;
		}
		for (int j=0; j<nCaracteres; j++) {
			c[j] = charInicial;
		}
		
		
		nSlave = nSlave + 1;
		char[] f;
		if(nSlave == nTotalSlaves) { 
			nCaracteres = nCaracteres + 1;
			nSlave = 0;
			f = new char[nCaracteres];
			char charFinal = stringLetras.charAt(0);
			ultimaPosicaoFinal = 0;
			for (int j=0; j<nCaracteres; j++) {
				f[j] = charFinal;
			}
		} else {
			f = new char[nCaracteres];
			int posicaoFinal = (nSlave * (stringLetras.length() / nTotalSlaves));
			ultimaPosicaoFinal = posicaoFinal;
			char charFinal = stringLetras.charAt(posicaoFinal);
			for (int j=0; j<nCaracteres; j++) {
				f[j] = charFinal;
			}
		}
		
		String[] strings = new String[2];
		strings[0] = String.valueOf(c);
		strings[1] = String.valueOf(f);
		if (stringEncontrada) {
			strings[0] = null;
			strings[1] = null;
		}
		return strings;
	}

	public synchronized void setStringGeradora(String stringGeradora) {
		stringEncontrada = true;
		JOptionPane.showMessageDialog(null, "String geradora " + stringGeradora + " \r\n Espere alguns instantes para todos os Slaves se encerrarem", "Informação", JOptionPane.INFORMATION_MESSAGE);
		System.out.println("String geradora: " + stringGeradora);
	}

}
