//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com]

package master;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class SlaveProxy extends Thread {
	private int pid;
	private String md5;
	private Monitor monitor;
	private Socket conexao;
	private Mensagem msgSaida;
	private slave.Mensagem msgEntrada;
	private String stringInicial, stringFinal, stringGeradora;
	private Boolean stringEncontrada;
	private ObjectOutputStream saiObject;
	private ObjectInputStream entraObject;
	
	public SlaveProxy (int pid, Monitor monitor, String stringMD5, Socket conexao ){
		this.pid = pid;
		this.monitor = monitor;
		this.md5 = stringMD5;
		this.conexao = conexao;
	}
	
	public void run(){				
        try {
   	
			saiObject = new ObjectOutputStream (conexao.getOutputStream());
			entraObject = new ObjectInputStream (conexao.getInputStream());
			
		} catch (IOException e) {e.printStackTrace();}
		
	    try {
	    	saiObject.writeObject(md5);
	    	saiObject.flush();
			
		} catch (IOException e) {e.printStackTrace();}
		
		do {
			String[] strings = monitor.getStrings();
			stringInicial = strings[0];
			stringFinal = strings[1];
			msgSaida = new Mensagem();
			msgSaida.setStringInicial(stringInicial);
			msgSaida.setStringFinal(stringFinal);
				
			System.out.println("Thread " + pid + " enviando strings: " + msgSaida.getStringInicial() + " - " + msgSaida.getStringFinal());
				
			try {
				 saiObject.writeObject(msgSaida);
				 saiObject.flush();
			} catch (IOException e) {e.printStackTrace();}
			
			stringEncontrada = (stringInicial == null);
			
			if (!stringEncontrada){
				msgEntrada = new slave.Mensagem();
		     	try {
					msgEntrada = ( slave.Mensagem ) entraObject.readObject();
				} catch (IOException e) {
					e.printStackTrace();
				} catch (ClassNotFoundException e) {
					e.printStackTrace();
				}
								  
				stringEncontrada = msgEntrada.getStringEncontrada();
				stringGeradora = msgEntrada.getStringGeradora();
			    
				System.out.println(stringEncontrada + " -> " + stringGeradora);
				
				if (stringEncontrada) {
					monitor.setStringGeradora(stringGeradora);
					
					msgSaida.setStringInicial(null);
					msgSaida.setStringFinal(null);
					try {
						 saiObject.writeObject(msgSaida);
						 saiObject.flush();
					} catch (IOException e) {e.printStackTrace();}
					
				}
			 }
		} while(!stringEncontrada);
		System.out.println("Thread " + pid + " finalizando.");
    }
}
