//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com]

package master.threads;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

import master.Master;
import master.Monitor;
import master.SlaveProxy;

public class ControladorConexoes extends Thread {
	
	private Master master;
	private ServerSocket serversocket;
	private Socket conexao;
	private Monitor monitor;
	private String md5;
	private int aceitados = 0;
	private int iniciados = 0;
	
	public ControladorConexoes(Master master, Monitor monitor, String md5, int porta) { 
		this.master = master;
		this.monitor = monitor;
		this.md5 = md5;
		try {
			serversocket = new ServerSocket(porta , 100);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void run() {
	    try {
	    	while(true) {
				conexao = serversocket.accept();
				System.out.println("Slave " + aceitados + " conectado.");
				master.slaveproxy[aceitados]= new SlaveProxy (aceitados, monitor, md5, conexao);
				aceitados++;
				monitor.setTotalSlaves(aceitados);
				
				if(master.slaveproxy[iniciados] != null) { 
					master.slaveproxy[iniciados].start();
					iniciados++;
				}
				try {
					sleep(100);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	    	}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
