//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com]

package misc;

import java.io.Serializable;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class MD5 implements Serializable {
	
	private static final long serialVersionUID = -7802268773858228960L;
	BigInteger hash;

	public MD5(String senha) {
		try  {  
			MessageDigest md = MessageDigest.getInstance("MD5");           
			md.update(senha.getBytes());  
			hash = new BigInteger(1, md.digest());  
		} catch(NoSuchAlgorithmException ns)  {  
			ns.printStackTrace();
		} 
	}
	
	protected BigInteger getHash() {
		return hash;
	}
	
	public String toString() {
		return hash.toString(16);
	}
	
	public boolean equals(MD5 md5) {
		return hash.equals(md5.getHash());
	}

}
