//    
//	  This file is part of MD5 Decrypter
//
//	  MD5 Decrypter is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

//	  Author: Matheus Bratfisch [matheusbrat AT gmail dot com]
// 	  Author: Olav P. Henschel [olav_ph at hotmail dot com]

package slave;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

import misc.MD5;

public class Slave {
	
	String ip;
	int porta;
	Socket conexao;
	ObjectInputStream inObject;
	ObjectOutputStream outObject;
	master.Mensagem msgEntrada = new master.Mensagem();
	Mensagem msgSaída = new Mensagem();
	
	public Slave(String ip, int porta) {
		this.ip = ip;
		this.porta = porta;
	}

	public void runSlave(){
		try{
		     conexao   = new Socket( ip, porta );
		     
		     inObject  = new  ObjectInputStream   ( conexao.getInputStream() );
             outObject = new  ObjectOutputStream  ( conexao.getOutputStream());
             
             String stringMD5 = (String) inObject.readObject();
             boolean stringEncontrada = false;
             
             System.out.println(stringMD5);
             
             while (!stringEncontrada) {
            	 msgEntrada = (master.Mensagem) inObject.readObject();
        	     if (msgEntrada.getStringInicial() == null) {
        	    	 break;
        	     }
        	     
        	     System.out.println(msgEntrada.getStringInicial() + " - " + msgEntrada.getStringFinal());
        	     
            	 SequenciaDeStrings ss = new SequenciaDeStrings(msgEntrada.getStringInicial());
            	 boolean chegouNaFinal = false;
            	 while (!chegouNaFinal) {
            		 MD5 str = new MD5(ss.toString());
            		 System.out.println(str.toString());
            		 if (str.toString().equals(stringMD5)) {
            			 stringEncontrada = true;
            			 System.out.println("Encontrada");
            			 break;
            		 }
            		 chegouNaFinal = ss.proximo().equals(msgEntrada.getStringFinal());
            	 }
        	     
            	 msgSaída = new Mensagem();
            	 msgSaída.setStringEncontrada(stringEncontrada);
            	 msgSaída.setStringGeradora(ss.toString());
            	 System.out.print("Enviando... ");
            	 outObject.writeObject(msgSaída);
	             outObject.flush();
	             System.out.println("OK");
             }
	    } catch (Exception e ) {
	    	e.printStackTrace();
	    }
	}

}
